/*
 * MSU CUDA Course Examples and Exercises.
 *
 * Copyright (c) 2011 Dmitry Mikushin
 *
 * This software is provided 'as-is', without any express or implied warranty.
 * In no event will the authors be held liable for any damages arising 
 * from the use of this software.
 * Permission is granted to anyone to use this software for any purpose, 
 * including commercial applications, and to alter it and redistribute it freely,
 * without any restrictons.
 */

#include <thrust/host_vector.h>
#include <thrust/device_vector.h>
#include <thrust/generate.h>
#include <thrust/transform.h>
#include <thrust/reduce.h>
#include <thrust/functional.h>
#include <thrust/sequence.h>

// Defines type for the user-supplied function.
typedef float (*external_device_func_t)
	(int index, float* array, int length);

// Defines main library class.
class Test
{
	int m_n;
	external_device_func_t* m_func;
	thrust::device_vector<float> device_array;

public:
	Test(char* filename, external_device_func_t* func);

	void FillVector();

	void PrintVector();
};

